      SUBROUTINE DEBIAS(BUF,OBUF,NSAMPS)
C     DEBIAS COMPUTES AND REMOVES THE BIAS (THE MEAN OF THE TRACE).
C  THIS ROUTINE WORKS IN HOST MEMORY.  THE COMPANION AP ROUTINE IS DEMEAN.
C
C COPYRIGHTED BY:
C  PAUL HENKART, SEISMIC REFLECTION PROCESSORS, SAN DIEGO, CA.
C  17 JANUARY 1982.  ALL RIGHTS RESERVED.
C
      DIMENSION BUF(1),OBUF(1)
C
      REALN=FLOAT(NSAMPS)
      AVE=0.
      DO 100 I=1,NSAMPS
  100 AVE=AVE+BUF(I)                                                     /* WATCH OUT FOR OVERFLOW - THIS COULD BE BUF(I)/REALN
      AVE=AVE/REALN                                                     /* BUT SAVING THE DIVIDES WILL REALLY HELP CUT CPU TIME.
      DO 200 I=1,NSAMPS
  200 OBUF(I)=BUF(I)-AVE
      RETURN
      END
