      SUBROUTINE MAXSC(TRACE,DEFF,NSAMPS,ITYPE,PEAK,TROUGH)
C****
C    A SUBROUTINE TO SCALE AN ARRAY SO THAT SOME SAMPLE IS +/- DEFF*RNIBS BIG.
C THIS IS A SCALING ROUTINE FOR VERSATEC SEISMIC TRACE PLOTS.
C ARGUMENTS:
C        TRACE  - THE ARRAY CONTAINING THE DATA.  THE SCALED DATA IS PLACED IN
C                 TRACE ALSO, THEREBY CLOBBERING THE ARRAY.
C        DEF    - THE VALUE OF THE LARGEST VALUE AFTER SCALING.  THE LARGEST
C                 VALUE WILL BE SCALED TO DEF.  ( ALSO THE DEFLECTION OF A TRACE
C        NSAMPS - NUMBER OF SAMPLES (16 BIT INTEGER)
C        ITYPE  - TYPE OF SCALE
C               =1, DELECTION IS MEASURED FROM THE PEAK TO THE ZERO LINE
C               =2, DEFLECTION IS MEASURED AS THE DISTANCE BETWEEN PEAK AND TROUGH
C        PEAK   - THE LARGEST POSITIVE VALUE WITIN ARRAY TRACE
C        TROUGH - THE MOST NEGATIVE VALUE IN ARRAY TRACE
C   NOTE THAT BOTH PEAK AND TROUGH ARE VALUES RETURNED BY MAXSC, THAT IS THEY
C  ARE SET BY MAXSC.
C     PAUL HENKART, SCRIPPS, DECEMBER 1978
c  mod 31 Mar 10 - get rid of aritmetic IF
C****
      DIMENSION TRACE(1)
      COMMON /VERSAT/NIBS,RNIBS
      COMMON /MAXSCS/NPRMUL,RMULT
      SAVE
      DATA N/0/, rmult1/0./
      PEAK=0.
      TROUGH=0.
      IF(RMULT1.NE.0.) RMULT=RMULT1                                      /* TRPLOT4 SAVES THE ORIGINAL VALUE OF RMULT
      IF(RMULT.LE.0.) GO TO 5
      X=RMULT
      GO TO 205
    5 DEF=DEFF*RNIBS
c      DO 100 I=1,NSAMPS
c      IF(TRACE(I))10,100,50
c   10 IF(TRACE(I).GE.TROUGH) GO TO 100
c      TROUGH=TRACE(I)
c      GO TO 100
c   50 IF(TRACE(I).LE.PEAK) GO TO 100
c      PEAK=TRACE(I)
c  100 CONTINUE
      DO i = 1, nsamps
         IF( trace(i) .LT. 0 ) THEN
             IF( trace(i) .LT. trough ) trough = trace(i)
         ELSE
             IF( trace(i) .GT. peak ) peak = trace(i)
         ENDIF
      ENDDO
      GO TO (200,300), ITYPE
  200 IF(PEAK.EQ.0.) RETURN                                              /* WHY MULTIPLY EVERYTHING BY 0
      X=DEF/PEAK
  205 CONTINUE
      IF(RMULT.LT.0.) GO TO 206
      IF(NPRMUL.EQ.0) GO TO 208
      IF(NPRMUL.LE.N) GO TO 208
  206 N=N+1
      PRINT 207,X
  207 FORMAT(' THE PLOT MULTIPLIER IS ',G10.4)
      IF(RMULT.LT.0.) RMULT1=X
  208 DO 210 I=1,NSAMPS
  210 TRACE(I)=TRACE(I)*X
      RETURN
  300 CONTINUE
      IF(PEAK-TROUGH.EQ.0.) RETURN                                       /* WHY MULTIPLY BY ZEROES
      X=DEF/AMAX1(ABS(PEAK),ABS(TROUGH))
      GO TO 205
      END
